c $Log:   /pvcs.config/mc3dvv/src/cnvtim.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:20:58 1997   pvcs
c 
c *************************************************************
c *   CNVTIM
c *************************************************************
      subroutine cnvtim (iui,timin,timout,scale,iunits)
      use module_precision
c
c convert timin (secs,mins,hrs,days,months,years) to timout and set
c iunits (secs,mins,hours,days,months,years)
c
      dimension sc(27), unit(6), ius(7)
      character iunits*8, unit*8
c
c input
c        iui    - timin units
c                 (1=secs,2=mins,3=hrs,4=days,5=months,6=years)
c        timin  - input time
c
c output
c        timout - input time/scale
c        scale  - 1./scale from scale table
c        iunits - timout units title
c
c scale table starting indices
      data ius /1,8,14,19,23,26,28/
c scale table
      data sc /1.,60.,3600.,86400.,2629800.,31557600.,1.e38,1.,60.,1440.
     1 ,43830.,525960.,1.e38,1.,24.,730.5,8766.,1.e38,1.,30.4375,365.25,
     2 1.e38,1.,12.,1.e38,1.,1.e38/
c unit titles
      data unit /' secs   ',' mins   ',' hours  ',' days   ',' months ',
     1 ' years  '/
c
      if (iui.lt.1.or.iui.gt.6) go to 20
      iuo=iui-1
      is=ius(iui)
      ie=ius(iui+1)-1
      do 10 i=is,ie
      iuo=iuo+1
      if (timin.ge.sc(i+1)) go to 10
      scale=1./sc(i)
      iunits=unit(iuo)
      timout=timin*scale
      go to 20
   10 continue
c bad news exit
   20 return
      end
