c $Log:   /pvcs.config/mc3dvv/src/namefile2.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:21:50 1997   pvcs
c 
c *************************************************************
c *   NAMEFILE2
c *************************************************************
      subroutine namefile2(icall,lund,iformat,root,tail)
c
c
c     icall= the number of times this routine has been called.
c            This value is used in putting a suffix on the output
c            file. The file names will have sequential suffixes. Suffix 
c            is between 10001 and 99999 if icall .gt. 0 and .lt. 89999.
c            You are on your own if you want more than 90000 files!
c
c     lund = logical unit number of file to be opened
c
c     root = raster file's name root to which suffix will be added.
c
c     tail = file's name tail will be added to the end of the file name.
c
c     iformat = 1 unformatted file is opened
c             = 2 formatted file is opened
c
c
      character*60 fname
      character*25 root
      character*25 tail
      character*5 ch5
      fname='                                                      '
c            12345678901234567890123456789012345678901234567890
c
c     name output file
c
      do 91 i=1,25
        if(tail(i:i).eq.' ') goto 2
 91   continue

 2    nchar_tail=i-1

      do 95 i=1,25
        if(root(i:i).eq.' ') goto 3
 95   continue

 3    nchar_root=i-1
      ncall=icall+10000
      write(ch5,5)ncall
    5 format(i5)
      do 96 i=1,nchar_root
         fname(i:i)=root(i:i)
  96  continue
      do 97 i=1,5
       fname(nchar_root+i:nchar_root+i)=ch5(i:i)
   97 continue
      do 98 i=1,nchar_tail
       fname(nchar_root+5+i:nchar_root+5+i)=tail(i:i)
   98 continue
c
c     open to output file
c
      if(iformat .eq. 1)then
      open(unit=lund,file=fname,form='unformatted')
      elseif(iformat .eq. 2)then
      open(unit=lund,file=fname,form='formatted')
      endif
c
      return
      end
