c $Log:   /pvcs.config/mc3dvv/src/rwssd.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:16 1997   pvcs
c 
c *************************************************************
c *   RWSSD
c *************************************************************
      subroutine rwssd(ifrw,irec,iqx,jqx,kqx,npssd,
     1                 vppl,v3pl,vtfpl,tautpl,tauppl,tau3pl)
c      subroutine rwssd(ifrw,irec)
      use module_precision
c
c     read and write from disk file
c     for use with ssd
c
c     ifrw= 1    write everything
c         = 2    read everything
c         =-2    read velocity, skip stress
c         =-3    read stress, skip velocity
c
c     irec=the record to be accessed
c
c      use module_param
      use module_giparam
      dimension vppl(iqx,jqx,kqx,npssd),v3pl(iqx,jqx,kqx,npssd),vtfpl
     1 (iqx,jqx,kqx,npssd),tautpl(iqx,jqx,kqx,npssd),tauppl(iqx,jqx,kqx
     2 ,npssd), tau3pl(iqx,jqx,kqx,npssd)
c
      lussd=50
      if(ifrw .eq. 2)then
      
         read(lussd)(((vppl(i,j,k,1)  ,i=1,iqx),j=1,jqx),k=1,kqx),
     1              (((v3pl(i,j,k,1)  ,i=1,iqx),j=1,jqx),k=1,kqx),
     2              (((vtfpl(i,j,k,1) ,i=1,iqx),j=1,jqx),k=1,kqx)
         
         read(lussd)(((tautpl(i,j,k,1),i=1,iqx),j=1,jqx),k=1,kqx),
     1              (((tauppl(i,j,k,1),i=1,iqx),j=1,jqx),k=1,kqx),
     2              (((tau3pl(i,j,k,1),i=1,iqx),j=1,jqx),k=1,kqx)
         
      elseif(ifrw .eq. -2)then
      
         read(lussd)(((vppl(i,j,k,1)  ,i=1,iqx),j=1,jqx),k=1,kqx),
     1              (((v3pl(i,j,k,1)  ,i=1,iqx),j=1,jqx),k=1,kqx),
     2              (((vtfpl(i,j,k,1) ,i=1,iqx),j=1,jqx),k=1,kqx)
c        read dummy record when stress is not needed
         read(lussd)dumtau
         
      elseif(ifrw .eq. -3)then
      
c     read dummy velocity when velocity is not needed
         read(lussd)dumvel
         
         read(lussd)(((tautpl(i,j,k,1),i=1,iqx),j=1,jqx),k=1,kqx),
     1              (((tauppl(i,j,k,1),i=1,iqx),j=1,jqx),k=1,kqx),
     2              (((tau3pl(i,j,k,1),i=1,iqx),j=1,jqx),k=1,kqx)
         
      elseif(ifrw .eq. 1)then
      
        write(lussd)(((vppl(i,j,k,1)  ,i=1,iqx),j=1,jqx),k=1,kqx),
     1              (((v3pl(i,j,k,1)  ,i=1,iqx),j=1,jqx),k=1,kqx),
     2              (((vtfpl(i,j,k,1) ,i=1,iqx),j=1,jqx),k=1,kqx)
         
        write(lussd)(((tautpl(i,j,k,1),i=1,iqx),j=1,jqx),k=1,kqx),
     1              (((tauppl(i,j,k,1),i=1,iqx),j=1,jqx),k=1,kqx),
     2              (((tau3pl(i,j,k,1),i=1,iqx),j=1,jqx),k=1,kqx)
         
      else
         write(6,10)ifrw
   10    format('error in rwssd ifrw= ',i8)
         stop
      endif
      return
      end
