c $Log:   /pvcs.config/mc3dvv/src/bc2.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:20:50 1997   pvcs
c 
c=======================================================================
	subroutine bc2(a,idim1,idim2,idim3,lpa,mpa,nza,lbd,mbd)
c                  
      use module_precision
c
	dimension a(idim1,idim2,idim3)
c
c  assign values to end points for periodic boundary based on
c    flags lpa,mpa
c 
c   Modified by G. Ito 12/93 to use idim1,idim2 instead of nxa, nya 
c**********************************************************************
c=====================================================================
        if ((lbd.eq.2).or.(mbd.eq.2))then
	  print *, '******* Stopped in bc2*********'
          print *, '**** not set for lbd,mbd=2****'
          stop
        endif
c	if (nya.eq.1) then
c	  nyap1=1
c        else
c	  nyap1=nya+1
c	endif
c
c  for each vertical plane
c
	do 70 k=1,nza
c-------------------------------------------------------
c  for boundary conditions periodic in x
c-------------------------------------------------------
	  if(lbd.eq.0) then
	    do 10 j=1,idim2
	      a(idim1,j,k)=a(1,j,k)
10	    continue
c-------------------------------------------------------
c  for boundary conditions reflecting in x
c-------------------------------------------------------
	  elseif(lbd.eq.1) then
	    if(lpa.eq.2) then
c	      sine transform
	      do 20 j=1,idim2
	        a(idim1,j,k)=zero
	        a(1,j,k)=zero
20	      continue
	    elseif(lpa.eq.4) then
c	      cosine transform
	    else
c	      real transform
	    endif
	  endif
c-------------------------------------------------------
c  for boundary conditions periodic in y
c-------------------------------------------------------
          if(idim2.eq.1) goto 70
	  if(mbd.eq.0) then
	    do 30 i=1,idim1
	      a(i,idim2,k)=a(i,1,k)
30	    continue
c-------------------------------------------------------
c  for boundary conditions reflecting in y
c-------------------------------------------------------
	  elseif(mbd.eq.1) then
	    if(mpa.eq.2) then
c	      sine transform
	      do 40 i=1,idim1
	        a(i,1,k)=zero
	        a(i,idim2,k)=zero
40	      continue
	    elseif(mpa.eq.4) then
c	      cosine transform
	    else
c	      real transform
	    endif
	  endif
c
70	continue
c
	return
	end
