c $Log:   /pvcs.config/mc3dvv/src/ctoft.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:21:02 1997   pvcs
c 
c *************************************************************
c *   CTOFT
c *************************************************************
      subroutine ctoft
      use module_precision
c
c     convert concentration at cell centers to cell corners
c
      use module_param
      use module_giparam
      use module_ac1
      use module_gia3
      use module_a3
      use module_a12
c     common /a12/ lpu, lpv, lpw, lpt13, lpt23, lpt33, lpft, nxu, nxv,
c    1 nxw, nxt13, nxt23, nxt33, nxft, nxr, mpu, mpv, mpw, mpt13, mpt23,
c    2 mpt33, mpft, nyu, nyv, nyw, nyt13, nyt23, nyt33, nyft, nyr
      use module_ftcoef
      use module_ctoft
      do 11 k=1,kcx
      do 11 j=1,jcx
      do 11 i=1,icx
        cc(i,j,k) = c(i,j,k,1)
  11  continue

      do 10 k=1,nz
      do 10 j=1,j3
      do 10 i=1,nx
      ft(i,j,k)=0.
   10 continue
c
      if ((lbd.eq.0).and.(mbd.eq.0)) then
c
        if (ny.eq.2) then
          do 30 k=2,nz-1
          do 20 i=1,nxr+1
          ft(i,1,k)=rat*.25*(cc(i,1,k)+cc(i+1,1,k)+
     1                       cc(i,1,k+1)+cc(i+1,1,k+1))
   20     continue
   30     continue
          do 40 i=1,nxr+1
          ft(i,1,1)=rat*0.5*(cc(i,1,1)+cc(i+1,1,1))
   40     ft(i,1,nz)=rat*0.5*(cc(i,1,nz1)+cc(i+1,1,nz1))
c
        else
c
          do 60 k=2,nz-1
          do 50 j=1,nyr+1
          do 50 i=1,nxr+1
          ft(i,j,k)=rat*.125*(cc(i,j,k)    + cc(i+1,j,k)+
     1                        cc(i,j+1,k)  + cc(i+1,j+1,k)+
     2                        cc(i,j,k+1)  + cc(i+1,j,k+1)+
     3                        cc(i,j+1,k+1)+ cc(i+1,j+1,k+1))
   50     continue
   60     continue
          do 70 j=1,nyr+1
          do 70 i=1,nxr+1
          ft(i,j,1)=rat*0.25*(cc(i,j,1)+cc(i+1,j,1)+
     1                        cc(i,j+1,1)+cc(i+1,j+1,1))
   70     ft(i,j,nz)=rat*0.25*(cc(i,j,nz1)+cc(i+1,j,nz1)+
     1                         cc(i,j+1,nz1)+cc(i+1,j+1,nz1))
        endif
c
      elseif ((lbd.eq.1).and.(mbd.eq.1)) then
c
        if (ny.eq.2) then
          do 80 i=2,nx-1
          ft(i,1,1)=rat*0.5*(cc(i,1,1)+cc(i+1,1,1))
   80     ft(i,1,nz)=rat*0.5*(cc(i,1,nz1)+cc(i+1,1,nz1))
          do 90 k=2,nz-1
          do 90 i=2,nx-1
   90     ft(i,1,k)=rat*0.25*(cc(i,1,k)+cc(i+1,1,k)+
     1                        cc(i,1,k+1)+cc(i+1,1,k+1))
          do 100 i=2,nx-1
          ft(i,1,1)=rat*0.5*(cc(i,1,1)+cc(i+1,1,1))
  100     ft(i,1,nz)=rat*.5*(cc(i,1,nz1)+cc(i+1,1,nz1))
          do 110 k=2,nz-1
          ft(1,1,k)=rat*0.5*(cc(1,1,k)+cc(1,1,k+1))
  110     ft(nx,1,k)=rat*0.5*(cc(nx1,1,k)+cc(nx1,1,k+1))
          do 120 k=2,nz-1
          ft(1,1,k)=rat*0.5*(cc(1,1,k)+cc(1,1,k+1))
  120     ft(nx,1,k)=rat*0.5*(cc(nx1,1,k)+cc(nx1,1,k+1))
          ft(1,1,1)=rat*cc(1,1,1)
          ft(1,1,nz)=rat*cc(1,1,nz1)
          ft(nx,1,1)=rat*cc(nx1,1,1)
          ft(nx,1,nz)=rat*cc(nx1,1,nz1)
        else
          do 140 k=2,nz-1
          do 130 j=2,ny-1
          do 130 i=2,nx-1
          ft(i,j,k)=rat*0.125*(cc(i,j,k)+cc(i+1,j,k)+
     1                         cc(i,j+1,k)+cc(i+1,j+1,k)+
     2                         cc(i,j,k+1)+cc(i+1,j,k+1)+
     3                         cc(i,j+1,k+1)+cc(i+1,j+1,k+1))
  130     continue
  140     continue
          do 150 j=2,ny-1
          do 150 i=2,nx-1
          ft(i,j,1)=rat*0.25*(cc(i,j,1)+cc(i+1,j,1)+
     1                        cc(i,j+1,1)+cc(i+1,j+1,1))
  150     ft(i,j,nz)=rat*0.25*(cc(i,j,nz1)+cc(i+1,j,nz1)+
     1                         cc(i,j+1,nz1)+cc(i+1,j+1,nz1))
          do 160 k=2,nz-1
          do 160 i=2,nx-1
          ft(i,1,k)=rat*0.25*(cc(i,1,k)+cc(i+1,1,k)+
     1                        cc(i,1,k+1)+cc(i+1,1,k+1))
  160     ft(i,ny,k)=rat*0.25*(cc(i,ny1,k)+cc(i+1,ny1,k)+
     1                         cc(i,ny1,k+1)+cc(i+1,ny1,k+1))
          do 170 i=2,nx-1
          ft(i,1,1)=rat*0.5*(cc(i,1,1)+cc(i+1,1,1))
          ft(i,1,nz)=rat*0.5*(cc(i,1,nz1)+cc(i+1,1,nz1))
          ft(i,ny,1)=rat*0.5*(cc(i,ny1,1)+cc(i+1,ny1,1))
  170     ft(i,ny,nz)=rat*.5*(cc(i,ny1,nz1)+cc(i+1,ny1,nz1))
          do 180 k=2,nz-1
          do 180 j=2,ny-1
          ft(1,j,k)=rat*0.25*(cc(1,j,k)+cc(1,j+1,k)+
     1                        cc(1,j,k+1)+cc(1,j+1,k+1))
  180     ft(nx,j,k)=rat*0.25*(cc(nx1,j,k)+cc(nx1,j+1,k)+
     1                         cc(nx1,j,k+1)+cc(nx1,j+1,k+1))
          do 190 j=2,ny-1
          ft(1,j,1)=rat*0.5*(cc(1,j,1)+cc(1,j+1,1))
          ft(1,j,nz)=rat*0.5*(cc(1,j,nz1)+cc(1,j+1,nz1))
          ft(nx,j,1)=rat*0.5*(cc(nx1,j,1)+cc(nx1,j+1,1))
  190     ft(nx,j,nz)=rat*0.5*(cc(nx1,j,nz1)+cc(nx1,j+1,nz1))
          do 200 k=2,nz-1
          ft(1,1,k)=rat*0.5*(cc(1,1,k)+cc(1,1,k+1))
          ft(1,ny,k)=rat*0.5*(cc(1,ny1,k)+cc(1,ny1,k+1))
          ft(nx,1,k)=rat*0.5*(cc(nx1,1,k)+cc(nx1,1,k+1))
  200     ft(nx,ny,k)=rat*0.5*(cc(nx1,ny1,k)+cc(nx1,ny1,k+1))
          ft(1,1,1)=rat*cc(1,1,1)
          ft(1,1,nz)=rat*cc(1,1,nz1)
          ft(1,ny,1)=rat*cc(1,ny1,1)
          ft(1,ny,nz)=rat*cc(1,ny1,nz1)
          ft(nx,1,1)=rat*cc(nx1,1,1)
          ft(nx,1,nz)=rat*cc(nx1,1,nz1)
          ft(nx,ny,1)=rat*cc(nx1,ny1,1)
          ft(nx,ny,nz)=rat*cc(nx1,ny1,nz1)
        endif
      else
c        not set up for mixed b.c.
      endif
c 
c cg
c cg temperary fix for t gt 1.0
c      noz=0
c      write(6,2115)itdim,jtdim,nz1,time
c      do 2111 kk=1,nz1
c      do 2111 jj=1,jnx
c      do 2111 ii=1,inx
c         if(cc(ii,jj,kk) .gt. 1.0)then
c         noz=noz+1
c         write(6,2115)ii,jj,kk,cc(ii,jj,kk)
c 2115    formacc('ttoft   T  ',3i5,e14.7)
c         cc(ii,jj,kk)=one
c         endif
c 2111 continue
c      write(6,*)noz
       
c 
      return
      end
