c $Log:   /pvcs.config/mc3dvv/src/meshbc.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:21:44 1997   pvcs
c 
c *************************************************************
c *   MESHBC
c *************************************************************
      subroutine meshbc(a,idx,idy,idz,nx,ny,nz,j1,j2,j3,j4,lbd,mbd)
c
c     set side boundary conditions of staggered mesh array
c     i.e. temperature , concentrations
c
      dimension a(idx,idy,idz)
      nx1 = nx + 1
      ny1 = ny + 1
c
c
      if (ny.ne.2) then
        if (mbd.eq.0) then
          do 20 k=2,nz
          do 10 i=2,nx
          a(i,1,k)=a(i,j3,k)
          a(i,j4,k)=a(i,j2,k)
   10     continue
   20     continue
        else
          do 40 k=2,nz
          do 30 i=2,nx
          a(i,1,k)=a(i,j2,k)
          a(i,j4,k)=a(i,j3,k)
   30     continue
   40     continue
        endif
      endif
      if (lbd.eq.0) then
        do 60 k=2,nz
        do 50 j=1,j3
        a(1,j,k)=a(nx,j,k)
        a(nx1,j,k)=a(2,j,k)
   50   continue
   60   continue
      else
        do 80 k=2,nz
        do 70 j=1,j3
        a(1,j,k)=a(2,j,k)
        a(nx1,j,k)=a(nx,j,k)
   70   continue
   80   continue
      endif
c
c ???
      if ((lbd.eq.1).and.(mbd.eq.1)) then
        if (ny.ne.2) then
          do 90 k=2,nz
          a(1,1,k)=a(2,j2,k)
          a(nx1,j4,k)=a(nx,j3,k)
          a(1,j4,k)=a(2,j3,k)
          a(nx1,1,k)=a(nx,j2,k)
   90     continue
        else
          do 100 k=2,nz
          a(1,1,k)=a(2,1,k)
          a(nx1,1,k)=a(nx,1,k)
          a(1,1,k)=a(2,1,k)
          a(nx1,1,k)=a(nx,1,k)
  100     continue
        endif
      endif
      if ((lbd.eq.0).and.(mbd.eq.0)) then
        if (ny.ne.2) then
          do 110 k=2,nz
          a(1,1,k)=a(nx,j3,k)
          a(nx1,j4,k)=a(2,j2,k)
          a(1,j4,k)=a(nx,j2,k)
          a(nx1,1,k)=a(2,j3,k)
  110     continue
        else
          do 120 k=2,nz
          a(1,1,k)=a(nx,1,k)
          a(nx1,1,k)=a(2,1,k)
          a(1,1,k)=a(nx,1,k)
          a(nx1,1,k)=a(2,1,k)
  120     continue
        endif
      endif
      if ((lbd.eq.0).and.(mbd.eq.1)) then
        write (6,380)
        stop
      endif
  380 format ("input error: mixed b.c. not tested in meshbc")
      return
      end
