c $Log:   /pvcs.config/mc3dvv/src/tempflip.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:28 1997   pvcs
c 
c *************************************************************
c *   TEMPFLIP
c *************************************************************
      subroutine tempflip(nx,ny,nz1,j1,j2,j3,j4,inx,jnx,knx,t)
      use module_precision
c
c     transform temperature field so that upwelling becomes
c     downwelling and visa versa.
c
      dimension t(inx,jnx,knx)
c
      div=float((nx-1)*(ny-1))
      do 20 k=1,nz1
        tavr=zero
        do 10 j=j2,j3
        do 10 i=2,nx
          tavr=tavr+t(i,j,k)
  10    continue
        tavr=tavr/div
        do 15 j=j1,j4
        do 15 i=1,nx+1
          t(i,j,k)=two*tavr-t(i,j,k)
  15    continue
  20  continue
 
      return
      end
