c $Log:   /pvcs.config/mc3dvv/src/difeq2.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:21:08 1997   pvcs
c 
c *************************************************************
c *   DIFEQ2
c *************************************************************
      subroutine difeq2(k,k1,k2,j9,ic3,ic4,indexv,ne,s,nsi,nsj,y,nyj,
     . nyk)
c     solution of toroidal field using relaxation
c     this provides partials and b.c.
      use module_precision
      use module_param
      use module_giparam
      use module_gia3
      use module_a3
      use module_viscom
      real l,l2
      common /a8/ l2,l,vps,vts
      dimension s(nsi,nsj),y(nyj,nyk),indexv(nyj)
      if(k .eq. k1) then
c
c     equations for bottom boundary
c
      do 10 ii=1,2
      do 10 jj=1,2
  10  s(jj,indexv(ii))=0.
      do 20 ii=1,2
      do 20 jj=1,2
  20  s(jj,2+indexv(ii))=0.
      if (ibcb .eq. 2) then
        s(2,2+indexv(1))=1.
        s(2,j9)=y(1,1)
      else
        s(2,2+indexv(2))=1.
        s(2,j9)=y(2,1)
      endif
      else if(k .gt. k2) then
c
c     equations for top boundary
c
      do 30 ii=1,2
      do 30 jj=1,2
  30  s(jj,indexv(ii))=0.
      do 40 ii=1,2
      do 40 jj=1,2
  40  s(jj,2+indexv(ii))=0.
      if (ibct .gt. 1)then
         s(1,2+indexv(1))=1.
         s(1,j9)=y(1,nz)-vts
      else
         s(1,2+indexv(2))=1.
         s(1,j9)=y(2,nz)
      endif
      else
c     equations for interior points
      dz=(z(k)-z(k-1))*0.5
      dzl=l*dz
      s(1,indexv(1))=-1.0
      s(1,indexv(2))=-dz*vnu(k-1)
      s(1,2+indexv(1))=1.0
      s(1,2+indexv(2))=-dz*vnu(k)
      s(2,indexv(1))=-dz*l2*vis(k-1)
      s(2,indexv(2))=-1.0
      s(2,2+indexv(1))=-dz*l2*vis(k)
      s(2,2+indexv(2))=1.0
      s(1,j9)=y(1,k)-y(1,k-1)-dz*(vnu(k)*y(2,k)+vnu(k-1)*y(2,k-1))
      s(2,j9)=y(2,k)-y(2,k-1)-dz*l2*(vis(k)*y(1,k)+vis(k-1)*y(1,k-1))
      endif
      return
      end
