c $Log:   /pvcs.config/mc3dvv/src/chvar.F_a  $
c
c   Rev 1.2   Tue Oct 06 16:04:26 1998   lowman
c
c
c   Rev 1.0   Mon Jul 14 14:20:58 1997   pvcs
c 
c *************************************************************
c *   CHVAR
c *************************************************************
      subroutine chvar_spwk (idim1,ncx,lbcx,idim2,ncy,mbcy,ncz,ifac)
      use module_precision
      use module_param    !+DaN
      use module_spwork   !+DaN
c
c     change of variables in frequency domain which is
c     multiplication by (+-i)
c     because complex variable are not used in the transform
c     the multplication by (i) is a change of order and sign
c     of the Fourier components
c
c     f is the only variable passed in which is changed
c
c      dimension f(idim1+1,idim2+1,*)
ccc      dimension f(65,1,65)
c
      if (lbcx.eq.0) then
c       change of variables
        if (ncy.gt.3) then
          do 30 k=1,ncz
          do 10 j=1,ncy
          do 10 i=2,ncx-1,2
          d1=spwk(i,j,k)
          spwk(i,j,k)=-spwk(i+1,j,k)
          spwk(i+1,j,k)=d1
   10     continue
          do 20 j=1,ncy
          spwk(ncx,j,k)=0.
   20     continue
   30     continue
c
c         for 2d case ncy=1
c
        elseif (ncy.eq.1) then
          do 50 k=1,ncz
          do 40 i=2,ncx-1,2
          d1=spwk(i,1,k)
          spwk(i,1,k)=-spwk(i+1,1,k)
          spwk(i+1,1,k)=d1
   40     continue
          spwk(ncx,1,k)=0.
   50     continue
        endif
      endif
      if (mbcy.eq.0) then
        if (ncy.gt.3) then
c         change of variables
          do 80 k=1,ncz
          do 60 j=2,ncy-1,2
          do 60 i=1,ncx
          d1=spwk(i,j,k)
          spwk(i,j,k)=-spwk(i,j+1,k)
          spwk(i,j+1,k)=d1
   60     continue
          do 70 i=1,ncx
          spwk(i,ncy,k)=0.
   70     continue
   80     continue
        elseif (ncy.eq.1) then
c
c   2-d case
c   no action in y direction
c
        endif
      endif
      return
      end
