c $Log:   /pvcs.config/mc3dvv/src/filt.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:21:16 1997   pvcs
c 
c *************************************************************
c *   FILT
c *************************************************************
c
c=============================================================
      subroutine filt(f,idimx,idimy,idimz,mx,my,mz,xfr1,xfr2)
c     apply cosine taper to spectrum
c=============================================================
      use module_precision
      dimension f(idimx,idimy,idimz)

      if (xfr1.eq.xfr2)goto 100
      pi=pimach(dumm)
      kx1=nint(float(mx-1)*xfr1)+1	!don't consider cos(0),sin(0) term
      kx2=nint(float(mx-1)*xfr2)+1
      ky1=nint(float(my-1)*xfr1)+1	
      ky2=nint(float(my-1)*xfr2)+1


      kdx=float(kx2-kx1)
      kdy=float(ky2-ky1)

      do 20 k=1,idimz
      do 10 j=1,idimy
        if (idimy.gt.2)then
          if (j.gt.ky2) then
	    wj=0.
          elseif(j.ge.ky1) then
	    t=float(j-ky1)/float(kdy)
	    wj=(cos(t*pi)+1)/2
          else
	    wj=1.
          endif
	else
	  wj=1.
        endif
      do 10 i=1,idimx
        if (i.gt.kx2) then
	  wi=0.
        elseif(i.ge.kx1) then
	  t=float(i-kx1)/float(kdx)
	  wi=(cos(t*pi)+1)/2
        else
	  wi=1.
        endif	
	w=wj*wi
        f(i,j,k)=wj*wi*f(i,j,k)
c	write(*,1000) w
 10   continue
 20   continue
 1000 format(f10.5)
c      stop
100   return
      end
