c $Log:   /pvcs.config/mc3dvv/src/tbase.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:26 1997   pvcs
c 
c *************************************************************
c *   TBASE
c *************************************************************
      subroutine tbase(ijob,t,inx,jnx,knx)
      use module_precision
c
c     impose basal temperature other than isothermal
c
c     ijob = 0 impose temperature on bottom boundary
c          = 1 impose temperature on top boundary
c
c  itop
c   or
c  ibot = indicator for insulated  boundary
c       = 0 isothermal  boundary
c       = 1 for insulated  boundary
c       < 0 for specified basal temperature in sub tbase
c         three digit number -xyz   where
c         x=wave number of sinusoidal variation in x
c         y=wave number of sinusoidal variation in y
c         z=amplitude of variation amp=(z/10.)
c
      use module_gia3
      use module_a3
      dimension t(inx,jnx,knx)
      
      if(ijob .eq. 0)then
c
c     extract value of x y z from ibot
c      
      itmp=-ibot
      amp=float(int(itmp/100))/10.
      alfy= float(int((float(itmp)-1000.*amp)/10.))
      alfx=float(int(((float(itmp)-1000.*amp))-10.*alfx))
c
c     set base temperature
c
      pi=pimach(dumm)
      tzl=pi/float(nz-1)
      txl=pi/xl
      tyl=pi/yl
      k=1
      do 10 j=j2,j4
      do 10 i=2,nx1
      ff=-0.5*dx
      fg=-0.5*dy
      if (i.eq.nx1) ff=0.
      if (j.eq.j4) fg=0.
      t(i,j,k)=1.0+amp*cos(txl*alfx*(float(i-1)*dx+ff))*cos(tyl
     1  *alfy*(float(j-1)*dy+fg))*sin(tzl*(float(k-1)-0.5))
   10 continue
      elseif(ijob .eq. 1)then
      
      endif
      return
      end
