c $Log:   /pvcs.config/mc3dvv/src/wheader.F_a  $
c
c   Rev 1.0   Mon Jul 14 14:22:44 1997   pvcs
c 
c *************************************************************
c *   WHEADER
c *************************************************************
      subroutine wheader (lu,ifrmt)
      use module_precision
c
c     write headers on output file (9/5/89 CWG)
c
c     ifrmt=1: unformatted write
c          =2: formatted write
c          =3: formatted write for avs header file, same as 2
c              but put a comment (#) at the beginning of each line.
c
c     dummy variables may be used with future versions
c
      use module_param
      use module_gia3
      use module_a3
      use module_giparam

      dz=1./float(nz-1)
      idum1=-999
      idum2=-999
      idum3=-999
      idum4=-999
      idum5=-999
      idum6=-999
      idum7=-999
      idum8=-999
      idum9=-999
      idum10=-999
      idum11=-999
      rdum1=-999.
      rdum2=bigd
      rdum3=sprate
      rdum3=sprate
      rdum4=delt
      rdum5=f0
      rdum6=cv1
      rdum7=cv2
      rdum8=rad
      rdum9=ram
      rdum10=relax
c      indicates whether tape11 and tape12 are single or double
c      precision
c
c     72 character title (72 bytes)
c
c     47 output variables  30 integer, 17 floating point
c
c     (328 bytes double precision)
c
      idum2=1
      if (ifrmt.eq.1) then
        write (lu) ptitle,nx,ny,nz,inx,jnx,knx,ijknx,lbd,mbd,icycle
     1  ,ivelp,idot3,ibcb,ibct,ibot,isurfv,nplate,ivistype,isolve,ivelp3
     2  ,idum2,idum3,idum4,idum5,idum6,idum7,idum8,idum9,idum10,idum11
     3  ,dx,dy,dz,xl,yl,rat,rah,time,rdum2,rdum3,rdum4,rdum5,rdum6
     4  ,rdum7,rdum8,rdum9,rdum10
      elseif (ifrmt.eq.2) then
        write (lu,10) ptitle,nx,ny,nz,inx,jnx,knx,ijknx,lbd,mbd,icycle
     1  ,ivelp,idot3,ibcb,ibct,ibot,isurfv,nplate,ivistype,isolve,ivelp3
     2  ,idum2,idum3,idum4,idum5,idum6,idum7,idum8,idum9,idum10,idum11
     3  ,dx,dy,dz,xl,yl,rat,rah,time,rdum2,rdum3,rdum4,rdum5,rdum6
     4  ,rdum7,rdum8,rdum9,rdum10
      elseif (ifrmt.eq.3) then
        write (lu,30) ptitle,nx,ny,nz,inx,jnx,knx,ijknx,lbd,mbd,icycle
     1  ,ivelp,idot3,ibcb,ibct,ibot,isurfv,nplate,ivistype,isolve,ivelp3
     2  ,idum2,idum3,idum4,idum5,idum6,idum7,idum8,idum9,idum10,idum11
     3  ,dx,dy,dz,xl,yl,rat,rah,time,rdum2,rdum3,rdum4,rdum5,rdum6
     4  ,rdum7,rdum8,rdum9,rdum10
      else
        write (6,20) ifrmt
        stop
      endif
      return
c
   10 format (a72,/,3(10i7,/),3(5e14.7,/),2e14.7)
   30 format ('# ',a72,/,3('# ',10i7,/),
     1      3('# ',5e14.7,/),'# ',2e14.7)
   20 format ('in wheader invalid format; ifrmt=',i8)
      end
