c *************************************************************
c *   FUNCINIT
c *
c *   Initializes temperature when INITLT==1 (see INIT.F)
c *   Default version: give conductive profile.
c *************************************************************
      function funcinit(xinit,yinit,zinit)
      use module_precision

#ifdef MPI
      include 'mpif.h'
#endif
 
      common/cinttaus/iholdstill

      funcinit = 1-zinit
#ifdef MPI
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr ) 
#else
      myid = 0
#endif

      if((xinit.eq.0).and.(yinit.eq.0).and.(zinit.eq.0)) then
      open(unit=57,file='input.jpl',status='old',iostat=ierr)
      if(ierr.eq.0)then
       read(57,*) ifuncper
       read(57,*) temp_junk
       read(57,*,iostat=ierread) iholdstill
       if (myid .eq. 0) then
       if(ierread.eq.0.and.iholdstill.eq.1)then
       write(*,*) '****************************'
       write(*,*) '****** iholdstill = 1 ******'
       write(*,*) '****** iholdstill = 1 ******'
       write(*,*) '****** iholdstill = 1 ******'
       write(*,*) '****************************'
       endif
       endif
      else
       ifuncper=100
      endif
      if(ifuncper.eq.0) return
      if (myid .eq. 0) then
      if (ifuncper.eq.1) then
       write(6,*) '**********************************************'
       write(6,*) 'Initial perturbation is of cos form in x and y'
      elseif(ifuncper.eq.2) then
       write(6,*) '**********************************************'
       write(6,*) 'Initial perturbation is cos in x and sin in y'
      elseif(ifuncper.eq.3) then
       write(6,*) '**********************************************'
       write(6,*) 'Initial perturbation is sin in x and cos in y'
      elseif(ifuncper.eq.4) then
       write(6,*) '**********************************************'
       write(6,*) 'Initial perturbation is of sin form in x and y'
      elseif(ifuncper.gt.11) then
       write(6,*) 'See funcper: ifuncper not supported/specified'
       stop
      endif
      endif
       close(unit=57)
      endif

      return
      end
