#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <math.h>
#include <string.h>

static  char name[80];

peras3out_(T,INX,INY,INZ,NX,NY,NZ,A,B,RMIN,RMAX,IFSCAL,FNAME)
int *INX,*INY,*INZ,*NX,*NY,*NZ;
int *IFSCAL;
double *RMIN,*RMAX,*A,*B;
double T[];
char FNAME[];
{
  int inx,iny,inz,nx,ny,nz,isc,ix,iy,iz,ip,ifscal,i;
  unsigned char fj;
  FILE *fp, *fopen();
  double rmin,rmax,a,b,tus;
 /* float frmin,frmax,ft1,ft2;*/
  
  
/* Copy Fortran name to C character array to get rid of the spaces */
  for (i=0;i<80;i++){
      if (FNAME[i] != 32){ 
              name[i]=FNAME[i];
      }
      else {
         name[i]=0;
         break;
      }
  }
  fp = fopen(name,"w");

  inx    = *INX;
  iny    = *INY;
  inz    = *INZ;
   nz    = *NZ;
   ny    = *NY;
   nx    = *NX;
  rmin   = *RMIN;
  rmax   = *RMAX;
  ifscal = *IFSCAL;
  a      = *A;
  b      = *B;
  /*
  frmin = (float) rmin;
  frmax = (float) rmax;*/
 /* printf("peras3out: %f %f \n",frmin,frmax);*/
  if (ifscal==0){
     for (iz=0;iz<nz;iz++)
      for (iy=0;iy<ny;iy++)
       for (ix=0;ix<nx;ix++){
         ip = ix + iy*inx + iz*inx*iny;
         tus = a*T[ip] + b;
         /*ft1 = (float) T[ip];
         ft2 = (float) tus;*/
  /*      printf("peras3out: %f %f \n",ft1,ft2); */
         fj = (unsigned char) tus;
         putc(fj,fp);
     }
  }
  if (ifscal!=0)
     for (iz=0;iz<nz;iz++)
      for (iy=0;iy<ny;iy++)
       for (ix=0;ix<nx;ix++){
         ip = ix + iy*inx + iz*inx*iny;
         tus = a*T[ip]+b;
         if (T[ip]>=rmax) tus = a*rmax+b;
         if (T[ip]<=rmin) tus = a*rmin+b;
         fj = (unsigned char) tus;
         putc(fj,fp);
     }
  fclose(fp);
}

peras3out (T,INX,INY,INZ,NX,NY,NZ,A,B,RMIN,RMAX,IFSCAL,FNAME)
int *INX,*INY,*INZ,*NX,*NY,*NZ;
int *IFSCAL;
double *RMIN,*RMAX,*A,*B;
double T[];
char FNAME[];
{
  int inx,iny,inz,nx,ny,nz,isc,ix,iy,iz,ip,ifscal,i;
  unsigned char fj;
  FILE *fp, *fopen();
  double rmin,rmax,a,b,tus;
  
  
/* Copy Fortran name to C character array to get rid of the spaces */
  for (i=0;i<80;i++){
      if (FNAME[i] != 32){ 
              name[i]=FNAME[i];
      }
      else {
         name[i]=0;
         break;
      }
  }
  fp = fopen(name,"w");

  inx    = *INX;
  iny    = *INY;
  inz    = *INZ;
   nz    = *NZ;
   ny    = *NY;
   nx    = *NX;
  rmin   = *RMIN;
  rmax   = *RMAX;
  ifscal = *IFSCAL;
  a      = *A;
  b      = *B;

  if (ifscal==0){
     for (iz=0;iz<nz;iz++)
      for (iy=0;iy<ny;iy++)
       for (ix=0;ix<nx;ix++){
         ip = ix + iy*inx + iz*inx*iny;
         tus = a*T[ip] + b;
         fj = (unsigned char) tus;
         putc(fj,fp);
     }
  }
  if (ifscal!=0)
     for (iz=0;iz<nz;iz++)
      for (iy=0;iy<ny;iy++)
       for (ix=0;ix<nx;ix++){
         ip = ix + iy*inx + iz*inx*iny;
         tus = a*T[ip]+b;
         if (T[ip]>=rmax) tus = a*rmax+b;
         if (T[ip]<=rmin) tus = a*rmin+b;
         fj = (unsigned char) tus;
         putc(fj,fp);
     }
  fclose(fp);
}

PERAS3OUT(T,INX,INY,INZ,NX,NY,NZ,A,B,RMIN,RMAX,IFSCAL,FNAME)
int *INX,*INY,*INZ,*NX,*NY,*NZ;
int *IFSCAL;
double *RMIN,*RMAX,*A,*B;
double T[];
char FNAME[];
{
  int inx,iny,inz,nx,ny,nz,isc,ix,iy,iz,ip,ifscal,i;
  unsigned char fj;
  FILE *fp, *fopen();
  double rmin,rmax,a,b,tus;
  
  
/* Copy Fortran name to C character array to get rid of the spaces */
  for (i=0;i<80;i++){
      if (FNAME[i] != 32){ 
              name[i]=FNAME[i];
      }
      else {
         name[i]=0;
         break;
      }
  }
  fp = fopen(name,"w");

  inx    = *INX;
  iny    = *INY;
  inz    = *INZ;
   nz    = *NZ;
   ny    = *NY;
   nx    = *NX;
  rmin   = *RMIN;
  rmax   = *RMAX;
  ifscal = *IFSCAL;
  a      = *A;
  b      = *B;

  if (ifscal==0){
     for (iz=0;iz<nz;iz++)
      for (iy=0;iy<ny;iy++)
       for (ix=0;ix<nx;ix++){
         ip = ix + iy*inx + iz*inx*iny;
         tus = a*T[ip] + b;
         fj = (unsigned char) tus;
         putc(fj,fp);
     }
  }
  if (ifscal!=0)
     for (iz=0;iz<nz;iz++)
      for (iy=0;iy<ny;iy++)
       for (ix=0;ix<nx;ix++){
         ip = ix + iy*inx + iz*inx*iny;
         tus = a*T[ip]+b;
         if (T[ip]>=rmax) tus = a*rmax+b;
         if (T[ip]<=rmin) tus = a*rmin+b;
         fj = (unsigned char) tus;
         putc(fj,fp);
     }
  fclose(fp);
}
