save_palette()
{
	extern int mydialog();
	extern int write_image();
	int answer,fd;
	unsigned char red[256],green[256],blue[256];
	char sname[MAXNAMELEN], *s;

	sname[0] = '\0';
	answer = mydialog("Palette: ","Save palette? Enter palette name:",
					sname, 0, 40,80);
	if(!answer || strlen(sname) == 0)  /* canceled */
	    msg_write("Warning: no palette is saved\r\n");
	else { /* write to disk */
	    s = (char *)rindex(sname,'.');
	    if(s == NULL || strcmp(s,".pal") != 0)
		strcat(sname, ".pal");
	   sprintf(msgstr,"Palette saved to %s\r\n",sname);
	   msg_write(msgstr);
	   if((fd=open(sname,O_RDWR|O_CREAT,0755)) == -1) {
		err_msg(E_NOFOPENW, sname);
		return(1);
	   }
	   pw_getcolormap(pw,0,color_index,red,green,blue);
	   write(fd,red,256);
	   write(fd,green,256);
	   write(fd,blue,256);
	   close(fd);
	}

	/* save image fiddled with value altered 
	sname[0] = '\0';
	answer=mydialog("Image: ","Save image? Enter image name:",sname,0,40,80);

	if(!answer || strlen(sname) == 0 || !fiddled) {
	    msg_write("Warning: no image is saved\r\n");
	}
	else {
	    if(alter_image(sname) == -1) {
	         msg_write("save_palette: no image is saved\r\n");
	    }
	}
	*/
}

alter_image(sname)
char *sname;
{
	extern int rev_image;
	int xdim = curr_image.xdim;    
	int ydim = curr_image.ydim;
	int xpos = curr_image.startx; 
	int ypos = curr_image.starty;
	struct pixrect *pr;
	struct mpr_data *mpr;
	unsigned char *s, val;
	char str[MAXNAMELEN];
	int fd, n, i;
	
	sprintf(str,".%dx%d", xdim,ydim);
	strcat(sname, str);

	/* open destination image file */
	if((fd = open(sname,O_RDWR|O_CREAT,0755)) == -1) {
	    err_msg(E_NOFOPENW, sname);
            return(-1);
	}

	/* create memory to read from canvas */
	if((pr = mem_create(xdim,ydim,8)) == NULL) {
	    err_msg(E_MEMCREAT);
	    close(fd);
	    return(-1);
	}
	pw_read(pr,0,0,xdim,ydim,PIX_SRC,pw,xpos,ypos);
	mpr = mpr_d(pr);
	if(rev_image) {
	    if(reverse_image(mpr->md_image,xdim,ydim) == -1) {
		pr_close(pr);
		close(fd);
		return(-1);
	    }
	}

	/* alter the pixel values of original image */
	s = (unsigned char *)mpr->md_image;
	for(i=0; i<xdim*ydim; i++, s++) {
	   val = *s;
	   *s = map[val];
	}
 
	/* write new image to disk */
	if((n=write(fd,mpr->md_image,xdim*ydim)) < 0) {
	    err_msg(E_NOFWRITE, sname);
	    pr_close(pr);
	    close(fd);
	    return(-1);
	}  
	if(n < xdim*ydim) {
	    err_msg(W_FEWWRITE, sname);
	}  
	sprintf(msgstr,"Image saved to %s\r\n",sname);
	msg_write(msgstr);
	pr_close(pr);
	close(fd);
	return(0);
}

