      program plotrast
c
c    color contour plot of raster file
c
      parameter(ii=256,jj=128,kk=128)
      character*72 root
      character*20 timehead
      character*4  chloop
      character*1  chifbr
      dimension iscal(2)
      dimension scal(2)
      dimension t(ii,jj,kk)
      dimension t2d(ii,kk)
      data lwtty, lrtty / 6, 5 /
      
      call getarg(1,chifbr)
      read(chifbr,5)ifbr
    5 format(i1)
    
      call opngks
      
      if(ifbr .eq. 0)then
c
c     run in interactive mode
c
      call frame
    1 write(lwtty,'(''Type root of input file name: '')')
      read(lrtty,'(a72)') root
      if(ichar(root).lt.33.and.len(root).lt.2) go to 1
      
      write(lwtty,'(''Enter dimensions of raster file: '')')
      write(lwtty,'(''NX NY NZ: '')')
      read(lrtty,*) nx, ny, nz
      
      write(lwtty,'(''Enter number of frame to plot: '')')
      read(lrtty,*) nframes
      iframe = nframes
      
      write
     1 (lwtty,'(''Enter RMIN RMAX data compression factors:'')')
      write(lwtty,'(''0.0 1.0  for standard problem'')')
      read(lrtty,*) scal(1), scal(2)
      
      write
     1 (lwtty,'(''Enter IMIN IMAX data compression factor: '')')
      write(lwtty,'(''20 250  for standard problem'')')
      read(lrtty,*) iscal(1), iscal(2)
      
      else
      
      open(20,file='plotrast.input')
      
      call getarg(2,root)
      
      call getarg(3,chloop)
      read(chloop,10)loop
   10 format(i4)
   
      read(20,*)ndx,ndy,ndz,nx,ny,nz
      
      do 20 lp=1,loop
      read(20,*)iframe, time, ifscal,
     1          iscal(1), iscal(2), scal(1), scal(2)
   20 continue
      print *,iframe, time, ifscal,
     1          iscal(1), iscal(2), scal(1), scal(2)

    
      close(20)
      endif
       
      call rastread(iframe,ii,jj,kk,nx,ny,nz,t,1,iscal,scal,root)
      ifcbar=0
      nzp1=nz+1
      do 25 k=1,nz
      do 25 i=1,nx
      k2d=nzp1-k
      t2d(i,k2d)=t(i,1,k)
c      print *,i,k,t(i,1,k)
  25  continue
      xl = float(nx)/float(nz-1)
      print *,xl
      call cplotcon2d(ii,kk,nx,nz,xl,t2d,ifcbar)
      CALL LABTOP ('TEMPERATURE',.017)

       
      write(timehead,30)time
  30  format('time= ',f7.3)
C
      call set (0.,1.,0.,1.,0.,1.,0.,1.,1)
      call plchhq (.8,.05,chloop,30.,0.,-1.)
      call plchhq (.1,.05,timehead,30.,0.,-1.)
       
       
       call clsgks
       
       stop
       end
